
import processing.serial.Serial;
Serial myPort;


import processing.video.*;

Capture video;
int l = 0;                                          //Länge der gesamten Möhre

String text = "";
String userPassword = "";
String realPassword = "start";




//Setup für die Kamera und den Bildschirm
void setup() {
  size(600, 200);
  
  String portName = Serial.list()[Serial.list().length-1];
  myPort = new Serial(this, portName, 9600);
  
  //Erstellt eine Liste der Namen der verfügbaren Kameras und gibt diese aus
  String[] cameras = Capture.list();
  if (cameras.length == 0) {
    println("Keine Kameras verfügbar.");
    exit();
  } else {
    println("Verfügbare Kameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
    
    //Nimmt das Bild einer gewählten Kamera auf
    video = new Capture(this, cameras[0]);
    video.start();
    
    //while(!userPassword.equals(realPassword)) println("es geht gleich los");
  }
}

void keyPressed(){
  if(keyCode == ENTER){
  userPassword = text;
  text = "";
  } else {
  text = text + key;
  } 
}



//Funktion wird ausgeführt, sobald die linke Maustaste gedrückt wird.
//Nimmt sämtliche Messungen der Möhre vor, berechnet einzelne Werte und gibt die Ergebnisse anschließend aus
void mousePressed() {
  int s = 0;                  //anzahl momentan gespeicherter x koordinaten
  int [] x = new int [3000];  //array für x koordinaten
  
  println("");
  println("");
  println("----- Neuer Durchgang -----");
  println("");
  int a =  50;                                            //deklariere länge der abschnitte, in denen breite gemessen wird, hier 20 pixel
  int w = 90000;                                          //deklariere gewünschtes Volumen (in Pixel^3, nicht cm^3)
  int wop = w*100/314;                 //w mit bereits durch p geteil, also Wunschvolumen Ohne Pi, auf diese art gelöst, da ich nicht weiß, wie man mit intger und double zsm arbeitet in java, daher einfach beides *100 und schon ist man nicht mehr hinterm komma

  
  //Länge der Möre
  //prüft von links nach rechts auf einer bestimmten Höhe y im Bild, welche Farbe die Pixel haben und bestimmt somit die Gesamtlänge der Möhre und gibt diese danach aus
  for (int i = 0; i < width; i++) {
    if (get(i, 100) != -1) {
      l += 1;
    } else {
      break;
    }
  }
   println("Länge der Möhre: ", l, "Pixel");
  
  int c = (l + a/2)/a;                                     //anzahl der abschnitte
  println("Anzahl der Abschnitte: ",c);
  
  //Breite der Abschnitte
  int [] d = new int [c];                                 //so viele variabeln in dem durchmesser-array, wie es abschnitte gibt
  int [] r = new int [c];
  int ln = l-a/2;                                         //stelle der ersten messung, kürzer als die anderen, erster schnitt nämlich bei a/2 
   for (int i = 0; i<c; i++){                             //messe die breite in jedem abschnitt; hole messungen bis es so viele wie abschnitte sind
     for(int k = 0; k < height; k++){
       if (get(ln-a*i, k) != -1) {
           d[i] += 1;
        }
     }
     r[i] = d[i]/2;                                       //aus breite der werte nun den radius für leichtere rechnung
     println("Radius",i,": ", r[i]);
   }
   
  int lr = l;                                              //kopie der länge der möre, verwendet bei rechnung
  //double e = l-a/2; //entfernung des ersten abschnittes von Halterung - unnötig, da abschnitt automatisch a/2 um r herum, weil anfang 1,5cm versetzt, nur für mich zur erinnerung gelassen


  for (int i = 0; i < c;i++){      //selber durchgang in jedem abschnitt, +1 weil i bei 0 anfängt, der 0. also bereits zhlt, c jedoch ganz normal von 1 startet
     
    int ls = wop /r[i] / r [i];        //länge der schnitte
    println("länge schnitte im ",i+1,". Abschnitt: ",ls);
    int as = a / ls;                     //Anzahl schnitte im abschnitt
  
    //ort der schnitte
    int q = 0;  //check variable in if schleife; führt zu sofortiger erfüllung des abbruchs, sobald lr kleiner als 0 werden würde
    for(int j = 0; lr > l-(a*i+a)+q; j++) {  //solange man noch in dem abschnitt ist, dessen radius man für die gegenwärtige länge benutzt
      lr = lr - ls;
      if (lr>0){
         x[j] = lr;
         s++;
         // println("Stelle ",s,". Schnitt: ",x[s]); //das sollte der code sein, der für mich sinn ergibt, lr wird in x[s] gespeichert, x[s] und der momentane lr sollten also immer übereinstimmen, tun sie aber nicht, in x ist sind immer noch nur nullen?!, deswegen die code zeile darunter
         //println("Stelle ",s,". Schnitt: ",lr);
         println(x[j]);
         myPort.write(x[j]);
         
      }
      else q=100; //durch q=100 ist lr in jedem falle kleiner als l+q (siehe kopf der while schleife)
      //x[s+1]=-1;
     // myPort.write(s);
      //for (int g=0; g<s; g++)
        //myPort.write(x[g]);
      
    }
   //myPort.write(x.length);
  /*    hier ist noch ein bisschen was durcheinander, soll die übergänge der abschnitte gleichmäßig halten, geht aber auch so
    int p=3; //PI ersatz, da java andauernd meckert, wenn man da eine dezimalzahl beim rechnen bei ints mitnimmt
    int l1 = 0;
    lr = l-(a*i+a); //sicher gehen, dass lr für nächsten abschnitt bereit ist
    int rl = a - ( as * ls );            //Restlänge
    int vr = p * r [i] * r[i];           //Restvolumen
    int v1 = w - vr;                     //Volumen 1. schnitt nächster abschnitt
    l1 = v1 / p / r[i] * r[i];       //länge 1. schnitt nächster abschnitt
    lr = lr-l1;
    x[s] = lr;
    s++;
    //double an = a - l1;            //neue länge 
 
  */ 
  
  }
  println("Anzahl der gespeicherten Schnitte: ",s);
}




//Gibt den einen Frame der Kamera aus, sobald dieser verfügbar ist und erzeugt somit ein flüssiges Bild auf dem Ausgabebildschirm
void captureEvent(Capture video) {
  video.read();
}



//zeichnet sämtliche Ausgaben auf den Bildschirm
void draw() {
  //if(userPassword.equals(realPassword)){
  background(0);
  image(video, 0, 0);  //stellt das Video auf die gleiche Größe wie die Bildfläche
  filter(THRESHOLD); //Filter für die Erkennung der Möhre auf dem Brett (Möhre wird schwarz und Hintergrund weiß dargestellt)
  //while(true);
  //} else println("falsch");
  //Hilfslinie zum Ausrichten der Kamera
  //stroke(204, 102, 0);
  //line(0, 100, 600, 100);
}
