#include <LinkedList.h>


#define MotorBlue_dir 5
#define MotorBlue_step 6

#define MotorBlack_dir 8
#define MotorBlack_step 9

#define MotorBoard_dir 11
#define MotorBoard_step 12

LinkedList<int> anzahl = LinkedList<int>();   //Liste, in die die Werte der Kamera gespeichert werden
LinkedList<int> steps = LinkedList<int>();

unsigned long laufzeitMotorBlue = micros();
unsigned long laufzeitMotorBlack = micros();

long MotorBlueIntervall = 1200;   //Motoren werden verschieden oft weiterbewegt, da einer deutlich schneller dreht
long MotorBlackIntervall = 2480;  //Blue wird alle 1200 microseconds bewegt, Black alle 2480


//Funktion, die das Brett hoch und runter bewegt
void move_vert(int dir, unsigned long dist) {

 if(dir == 0) { //bewegt das Brett runter
    digitalWrite(MotorBlue_dir, LOW);
    digitalWrite(MotorBlack_dir, LOW);
 }
 else if(dir == 1) { //bewegt das Brett hoch
    digitalWrite(MotorBlue_dir, HIGH);
    digitalWrite(MotorBlack_dir, HIGH);
 }

//Berechung sorgt dafür, dass sich die Motoren parallel und gleich schnell bewegen
 for(unsigned long i = 0; i < dist; i++) {
  unsigned long currentMotorBlue = micros();
  unsigned long currentMotorBlack = micros();

  digitalWrite(MotorBlue_step, LOW);
  digitalWrite(MotorBlack_step, LOW);

  if(currentMotorBlue - laufzeitMotorBlue > MotorBlueIntervall){
    digitalWrite(MotorBlue_step, HIGH);
    laufzeitMotorBlue = currentMotorBlue;
    }

  if(currentMotorBlack - laufzeitMotorBlack > MotorBlackIntervall){
    digitalWrite(MotorBlack_step, HIGH);
    laufzeitMotorBlack = currentMotorBlack;
    }
  }
}


//Funktion, die das Objekt nach vorne bewegt
void move_hor(int dir, double dist) {
 if(dir == 0) {
   digitalWrite(MotorBoard_dir, HIGH);
 }
 else {
   digitalWrite(MotorBoard_dir, LOW);
 }
 for(int i = 0; i < dist; i++) {
  digitalWrite(MotorBoard_step, HIGH);
  delayMicroseconds(2000);
  digitalWrite(MotorBoard_step, LOW);
  delayMicroseconds(2000);
 }
}



void setup() {
  Serial.begin(9600);
  
  pinMode(MotorBlue_dir, OUTPUT);
  pinMode(MotorBlue_step, OUTPUT);

  pinMode(MotorBlack_dir, OUTPUT);
  pinMode(MotorBlack_step, OUTPUT);

  pinMode(MotorBoard_dir, OUTPUT);
  pinMode(MotorBoard_step, OUTPUT);  
}

void loop() {
  /*
  Serial.println("Please enter your password: ");
  while(Serial.available() == 0){}
  String input = Serial.readString(); //liest String über Seriellen Monitor ein
  */
  if(Serial.available()){
    int myObject = Serial.parseInt();
    anzahl.add(myObject);
    
    for(int i = 0; i < anzahl.size(); i++){
      if(i == 0) steps.add(anzahl.get(i));
      else steps.add(anzahl.get(i) - anzahl.get(i-1));
    }
  
  //if(input == password){    //startet, wenn der eingegebene String "start" entspricht
                            //es könnte hier zu Problemen mit den geschickten Daten von processing kommen. An der Kommunikation zw Arduino und processing arbeiten wir noch
    
    for(int i = 0; i < anzahl.size(); i++) {    //for Schleife wird so oft ausgeführt, bis die Möhre vollständig geschnitten ist. i < 500 wird noch ersetzt durch die Anzahl der vorzunehmenden Schnitte, die aus der Berechnung in processing hervorgeht
      move_vert(1, 150000);
      delay(500);
      move_hor(1, (unsigned long)steps.get(i) * 20);                  //hier wird die 200 noch durch Länge der Schnitte ersetzt
      delay(500);
      move_vert(0, 150000);
      delay(500);
    }
   }
 
  //}
}
